<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" label-width="68px">    
      <el-form-item label="系统用户ID" prop="userId">
        <el-input
            v-model="queryParams.userId"
            placeholder="请输入系统用户ID"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>    
      <el-form-item label="当前系统id" prop="orderId">
        <el-input
            v-model="queryParams.orderId"
            placeholder="请输入当前系统id"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>    
      <el-form-item label="交易类型" prop="type">
        <el-select v-model="queryParams.type" placeholder="请选择交易类型" clearable size="small">
            <el-option
                v-for="dict in typeOptions"
                :key="dict.key"
                :label="dict.value"
                :value="dict.key"
            />
        </el-select>
      </el-form-item>    
      <el-form-item label="金额" prop="payFee">
        <el-input
            v-model="queryParams.payFee"
            placeholder="请输入金额"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>      
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['jx_horizon/jxHorizonConsume/add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['jx_horizon/jxHorizonConsume/edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['jx_horizon/jxHorizonConsume/delete']"
        >删除</el-button>
      </el-col>
    </el-row>
    <el-table v-loading="loading" :data="jxHorizonConsumeList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />      
      <el-table-column label="系统id" align="center" prop="id" />      
      <el-table-column label="系统用户ID" align="center" prop="userId" />      
      <el-table-column label="当前系统id" align="center" prop="orderId" />      
      <el-table-column label="交易类型" align="center" prop="type" :formatter="typeFormat" />      
      <el-table-column label="金额" align="center" prop="payFee" />      
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['jx_horizon/jxHorizonConsume/edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['jx_horizon/jxHorizonConsume/delete']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!-- 添加或修改消费记录对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">       
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>
<script>
import {
    listJxHorizonConsume,
    getJxHorizonConsume,
    delJxHorizonConsume,
    addJxHorizonConsume,
    updateJxHorizonConsume,    
} from "@/api/jx_horizon/jxHorizonConsume";
export default {
  components:{    
  },
  name: "JxHorizonConsume",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 消费记录表格数据
      jxHorizonConsumeList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,      
      // typeOptions字典数据
      typeOptions: [],      
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        createdAt: undefined,
        userId: undefined,
        orderId: undefined,
        type: undefined,
        payFee: undefined,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: { 
        createdAt : [
          { required: true, message: "创建时间不能为空", trigger: "blur" }
        ],
        userId : [
          { required: true, message: "系统用户ID不能为空", trigger: "blur" }
        ],
        orderId : [
          { required: true, message: "当前系统id不能为空", trigger: "blur" }
        ],
        type : [
          { required: true, message: "交易类型不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {    
    this.getDicts("pay_type").then(response => {
      this.typeOptions = response.data.values||[];
    });
    this.getList();
  },
  methods: {    
    /** 查询消费记录列表 */
    getList() {
      this.loading = true;
      listJxHorizonConsume(this.queryParams).then(response => {
        let list = response.data.list || [];        
        this.jxHorizonConsumeList = list;        
        this.total = response.data.total;
        this.loading = false;
      });
    },    
    // 交易类型字典翻译
    typeFormat(row, column) {
      return this.selectDictLabel(this.typeOptions, row.type);
    },    
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {        
        createdAt: undefined,        
        updatedAt: undefined,        
        id: undefined,        
        userId: undefined,        
        orderId: undefined,        
        type: undefined,        
        payFee: undefined,        
      };      
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!=1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加消费记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getJxHorizonConsume(id).then(response => {
        let data = response.data;        
        data.type = ''+data.type        
        this.form = data;
        this.open = true;
        this.title = "修改消费记录";
      });
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != undefined) {
            updateJxHorizonConsume(this.form).then(response => {
              if (response.code === 0) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              } else {
                this.msgError(response.msg);
              }
            });
          } else {
            addJxHorizonConsume(this.form).then(response => {
              if (response.code === 0) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              } else {
                this.msgError(response.msg);
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除消费记录编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delJxHorizonConsume(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    }
  }
};
</script>
<style>
</style>